/*
 * Version: Open Software License v. 2.1
 *
 * The contents of this file are subject to the Open Software License Version
 * 2.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.opensource.org/licenses/osl-2.1.php
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is the FacebookLike.
 *
 * The Initial Developer of the Original Code is
 * SimilarWeb Ltd.
 *
 * Portions created by the Initial Developer are Copyright (C) 2008
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 * */

var FacebookLikeOptions = function() {
    var pub = {};

// public consts
    pub.CHECKBOXES = {
        general: new Array("hideButtonText")
    };

// public functions
    pub.init = function(isInstall) {
        for (var checkboxGroupName in pub.CHECKBOXES) {
            var checkboxGroup = pub.CHECKBOXES[checkboxGroupName];
            for each (checkboxOption in checkboxGroup) {
                if (FacebookLike.PREFS.getBoolPref(checkboxOption, true))
                    var state = "true"
                else
                    var state = "false"
                if (document.getElementById(checkboxOption))
                    document.getElementById(checkboxOption).setAttribute("checked", state);
            }
        }
    };
    
    pub.save = function() {
        var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
        var enumerator = windowMediator.getEnumerator("navigator:browser");
        var browserWindow = windowMediator.getMostRecentWindow("navigator:browser");
        var mainDocument = browserWindow.document;
        for (var checkboxGroupName in pub.CHECKBOXES) {
            var checkboxGroup = pub.CHECKBOXES[checkboxGroupName];
            for each (checkboxOption in checkboxGroup) {
                if (!document.getElementById(checkboxOption))
                    continue;           
                if (document.getElementById(checkboxOption).getAttribute("checked")=="true") {
                    FacebookLike.PREFS.setBoolPref(checkboxOption, true);
                    var hiddenState = "false"
                } else {
                    FacebookLike.PREFS.setBoolPref(checkboxOption, false);
                    var hiddenState = "true"
                }
            }
        }
        // initialize toolbar button text
        var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
        var enumerator = windowMediator.getEnumerator("navigator:browser");
        while(enumerator.hasMoreElements()) {
            var win = enumerator.getNext();
            var toolbarButton = win.document.getElementById('FacebookLikeStatusbarButtonLabel');
            if (FacebookLike.PREFS.getBoolPref("hideButtonText"))
                toolbarButton.setAttribute("value", "");
            else
                toolbarButton.setAttribute("value", "Like");
        }
    };

    pub.openHelp = function() {
        var windowMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
        var mainDocument = windowMediator.getMostRecentWindow("navigator:browser").document;
    };

    return pub;
}();